/*
 * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
 * Copyright (C) 2008 Alp Toker <alp@atoker.com>
 * Copyright (C) 2008 Apple Inc.
 */
#ifndef __GdomUIEvent_H__
#define __GdomUIEvent_H__
#include <webkit/webkitdefines.h>
#include "gdom/GdomDOMWindow.h"
#include "gdom/GdomEvent.h"
#include "glib-object.h"


G_BEGIN_DECLS

typedef struct _GdomUIEvent GdomUIEvent;
typedef struct _GdomUIEventClass GdomUIEventClass;


#define GDOM_TYPE_UI_EVENT            (gdom_ui_event_get_type())
#define GDOM_UI_EVENT(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_UI_EVENT, GdomUIEvent))
#define GDOM_UI_EVENT_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_UI_EVENT, GdomUIEvent)Class)
#define GDOM_IS_UI_EVENT(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_UI_EVENT))
#define GDOM_IS_UI_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_UI_EVENT))
#define GDOM_UI_EVENT_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_UI_EVENT, GdomUIEventClass))

typedef struct _GdomUIEventPrivate GdomUIEventPrivate;

struct _GdomUIEvent {
    GdomEvent parent_instance;
    GdomUIEventPrivate *priv;
};

struct _GdomUIEventClass {
    GObjectClass parent_class;
};

WEBKIT_API GType
gdom_ui_event_get_type (void);

WEBKIT_API void
gdom_ui_event_init_ui_event (GdomUIEvent *thiz, gchar * type, gboolean can_bubble, gboolean cancelable, GdomDOMWindow * view, glong detail);

G_END_DECLS

#endif /* __GdomUIEvent_H__ */
